PROG  EQU	0000h
      ORG	PROG+0000h
	SJMP	START

; 中斷向量表
      ORG	PROG+0023h
	LCALL	UART_ISR
	RETI
;
      ORG   PROG+0030h
START:
      MOV   TMOD,#00100001b	; Timer1 in Mode 2, Timer0 in Mode 1
      MOV   SCON,#01010000b	; UART in Mode 1
      MOV   TH1,#0FDh		; Baud Rate = 9600 bps at 11.0592MHz
      SETB	ES			; Enable UART Interrupt
      SETB	EA			; Enable Interrupt
      SETB	TR1			; Start Timer 1

      SETB  TI                ; 將 TI 設為 1，表示 UART 可以傳送資料
      SJMP  $                 ; 停留在這裡

UART_ISR:
      JB    RI, RECEIVED	; 有輸入資料時，跳到 RECEIVED 進行讀取
TRANSMITTED:
      CLR   TI	
      MOV   A, P0
      CPL   A

      MOV   SBUF, A            ; 傳送 DIP Switch 的值
      RET
RECEIVED:
      CLR   RI
      MOV   A, SBUF
      ; 將 DIP Switch 的值與 UART 接收到的資料相加
      CPL   A
      ADD   A, P0
      INC   A

      MOV   P1, A			; 顯示結果在 LED 燈上
      RET
      END

      