ORG 0000h

    MOV     TMOD,#00100001b	; Timer1 in Mode 2, Timer0 in Mode 1
    MOV     SCON,#01010000b	; UART in Mode 1
    MOV     TH1,#0FDh		; Baud Rate = 9600 bps at 11.0592MHz
    SETB	TR1				; Start Timer 1

    SETB    TI              ; 將 TI 設為 1，表示 UART 可以傳送資料
LOOP:
    JB      RI, RECV		; 有輸入資料時，跳到 RECV
    JB      TI, SEND		; 能傳送資料時，跳到 SEND
    SJMP    LOOP			; 無資料時繼續迴圈

RECV:
    CLR     RI
    MOV     A, SBUF   	    ; Read UART data

    ; 將 DIP Switch 的值與 UART 接收到的資料相加
    CPL     A
    ADD     A, P0
    INC     A

    MOV     P1, A			; 顯示結果在 LED 燈上
    LJMP    LOOP

SEND:
    CLR     TI	
    MOV     A, P0
    CPL     A

    MOV     SBUF,A          ; 傳送 DIP Switch 的值
    LJMP    LOOP
END


